<script lang="ts">
import Vue from 'vue';
import { init } from 'aos';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';

export default Vue.extend({
  async asyncData({ $content }) {
    const doc = await $content('learn/index').fetch();
    return { doc };
  },
  data() {
    return {
      cards: [],
      filters: [],
      properties: [
        'level',
        'pace',
        'assessment',
        'registration',
        'confidentiality',
        'maintainer',
      ],
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).doc, this.$route.path);
  },
  watch: {
    filters: {
      handler() {
        this.populateCards();
      },
      deep: true,
    },
  },
  mounted() {
    this.populateFilters();
    this.populateCards();
  },
  beforeMount() {
    init({
      once: true,
    });
  },
  methods: {
    populateCards() {
      this.cards = this.doc.programs.filter((card) => {
        return this.filters.every((filter) => {
          return (
            filter.selected === card[filter.property] ||
            filter.selected.startsWith('Any')
          );
        });
      });
    },
    /*
      Sample data:
      filters = [
        {
          name: "Use-Case",
          options: ["Talent Development", "Continuous Integration"],
          selected: "Any use-case"
        },
        {
          name: "Level",
          options: ["Beginner", "Intermediate", "Advanced"],
          selected: "Beginner"
        }
      ]
    */
    populateFilters() {
      this.filters = [
        this.getAllUniqueOptions('use_case', 'Use-Case'),
        this.getAllUniqueOptions('level', 'Level'),
        this.getAllUniqueOptions('pace', 'Pace'),
        this.getAllUniqueOptions('assessment', 'Assessment'),
        this.getAllUniqueOptions('registration', 'Registration'),
        this.getAllUniqueOptions('confidentiality', 'Confidentiality'),
        this.getAllUniqueOptions('maintainer', 'Maintainer'),
      ];
    },
    getAllUniqueOptions(property, displayName) {
      const placeholder = `Any ${displayName.toLowerCase()}`;
      const cleanedListOfOptions = this.doc.programs
        .map((program) => program[property])
        .filter((program) => program != null);
      cleanedListOfOptions.unshift(placeholder);

      return {
        name: displayName,
        options: [...new Set(cleanedListOfOptions)],
        property,
        selected: placeholder,
      };
    },
    resetAll() {
      this.populateFilters();
    },
  },
});
</script>

<template>
  <div>
    <SlpTopButton data-ga-name="to-top" data-ga-location="body" />
    <SlpContainer>
      <SlpTypography tag="h1" variant="display1" class="slp-mt-64">{{
        doc.title
      }}</SlpTypography>
      <SlpTypography tag="h4" variant="heading4" class="slp-mt-48">{{
        doc.description
      }}</SlpTypography>
      <div class="slp-mt-32 slp-mb-48">
        <SlpButton
          :href="doc.free_trial_link.link"
          :data-ga-name="doc.free_trial_link.data_ga_name"
          :data-ga-location="doc.free_trial_link.data_ga_location"
          class="learn-free-trial-btn"
        >
          {{ doc.free_trial_link.title }}
        </SlpButton>
        <SlpButton
          :href="doc.certifications_link.link"
          :data-ga-name="doc.certifications_link.data_ga_name"
          :data-ga-location="doc.certifications_link.data_ga_location"
          variant="tertiary"
        >
          {{ doc.certifications_link.title }}
          <SlpIcon
            class="slp-ml-16"
            name="chevron-lg-right"
            variant="product"
            hex-color="#171321"
            alt="Chevron Right Icon"
          />
        </SlpButton>
      </div>
    </SlpContainer>
    <SlpContainer variant="light-purple-100" class="slp-pt-32 slp-pb-64">
      <section class="filter-grid">
        <div v-for="filter in filters" :key="filter.name" class="filter">
          <SlpTypography variant="body3-bold">{{ filter.name }}</SlpTypography>
          <SlpDropdown
            v-model="filter.selected"
            class="filter-dropdown"
            name="filter-dropdown"
            :options="filter.options"
            dropdown-label="filter-dropdown"
          />
        </div>
        <SlpButton
          class="reset-all__button"
          variant="ghost"
          @click.native="resetAll"
        >
          <SlpTypography variant="body2-bold" class="slp-mr-8"
            >&times;
          </SlpTypography>
          <SlpTypography variant="body3-bold">{{
            doc.reset_all
          }}</SlpTypography>
        </SlpButton>
      </section>
      <section class="program-grid">
        <article v-for="program in cards" :key="program.name">
          <a :href="program.url" class="program-card">
            <div class="program-card-top">
              <SlpTypography
                v-show="program.use_case"
                variant="all-caps"
                tag="p"
                class="slp-mb-24"
                >{{ program.use_case }}</SlpTypography
              >
              <SlpTypography
                v-show="program.name"
                variant="heading5-bold"
                tag="h3"
                class="slp-mb-8"
                >{{ program.name }}</SlpTypography
              >
              <SlpTypography
                v-show="program.description"
                variant="body2"
                tag="p"
                >{{ program.description }}</SlpTypography
              >
            </div>
            <div class="program-card-bottom slp-mt-24">
              <div v-for="property in properties" :key="property">
                <SlpHorizontalRule />
                <SlpRow>
                  <SlpColumn :cols="6">
                    <SlpTypography variant="body3">{{
                      doc[property]
                    }}</SlpTypography>
                  </SlpColumn>
                  <SlpColumn :cols="6">
                    <SlpTypography variant="body3-bold">{{
                      program[property]
                    }}</SlpTypography>
                  </SlpColumn>
                </SlpRow>
              </div>
              <SlpHorizontalRule />
            </div>
          </a>
        </article>
      </section>
    </SlpContainer>
  </div>
</template>

<style lang="scss">
.slp-top-btn {
  border: 1px solid $color-surface-950 !important;
}

.filter {
  position: relative;

  &-grid {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr 1fr;
    grid-gap: $spacing-32;
    margin-top: $spacing-32;

    @media (max-width: $breakpoint-md) {
      grid-template-columns: 1fr;
    }
  }
}

.reset-all__button {
  margin-top: $spacing-24;
  color: $color-text-link-100;
}

.dropdown::after {
  top: 34px !important;
}

.filter-dropdown {
  background: $color-surface-50;
}

.program {
  &-grid {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-gap: $spacing-32;
    margin-top: $spacing-64;

    @media (max-width: $breakpoint-md) {
      grid-template-columns: 1fr;
    }
  }

  &-card {
    background-color: $color-surface-50;
    padding: $spacing-32 $spacing-24;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    border-radius: $border-radius-4;
    transition: all 0.3s ease-in;
    color: initial !important;
    height: 100%;

    &:hover {
      box-shadow: 0 24px 50px -16px #d1d0d3;
    }

    .slp-hr {
      margin-top: 6px;
      margin-bottom: 6px;
      border-bottom: 0px;
      border-color: $color-surface-900;
    }
  }
}

@media (max-width: $breakpoint-md) {
  .learn-free-trial-btn {
    width: 100%;
    margin-bottom: $spacing-8;
    display: block !important;
  }
}
</style>
